lg = love.graphics
lp = love.physics
lw = love.window
lm = love.mouse

function love.keypressed(key)
    if key == "escape" then love.event.quit() end
end

function love.load()
    lw.setMode(50, 50, {borderless = true, display = 1, x = 0, y = 0})

    dw, dh = lw.getDesktopDimensions(1)

    lp.setMeter(50)
    world = lp.newWorld(0, 9.81*50, true)

    objects = {}

    objects.ground = {}
    objects.ground.body = love.physics.newBody(world, dw/2, dh)
    objects.ground.shape = love.physics.newRectangleShape(dw, 1)
    objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape)

    objects.ball = {}
    objects.ball.body = love.physics.newBody(world, dw/2, dh/2, "dynamic")
    objects.ball.shape = love.physics.newCircleShape(25)
    objects.ball.fixture = love.physics.newFixture(objects.ball.body, objects.ball.shape, 1)
    objects.ball.fixture:setRestitution(0.7)

    font = lg.newFont(12)
    lg.setFont(font)
end

function love.update(dt)
    world:update(dt)

    if love.keyboard.isDown("right") then
        objects.ball.body:applyForce(400, 0)
    elseif love.keyboard.isDown("left") then
        objects.ball.body:applyForce(-400, 0)
    elseif love.keyboard.isDown("up") then
        objects.ball.body:applyForce(0, -800)
    elseif love.keyboard.isDown("r") then
        objects.ball.body:setPosition(dw/2, 20)
        objects.ball.body:setLinearVelocity(0, 0)
    end

    local bx, by = objects.ball.body:getPosition()
    if bx > dw or bx < 0 or by > dh or by < 0 then
        objects.ball.body:setPosition(dw/2, 20)
    end
end

function love.draw()
    local x, y = objects.ball.body:getPosition()
    lw.setPosition(x, y)

    lg.printf("by\nMiras", 0, 25-font:getHeight(), 50, "center")
end